
;;; Require
(require 'auto-complete)
(require 'auto-complete-magik nil t)


;; Generic setup.
(global-auto-complete-mode t)           ;enable global-mode

(setq ac-auto-start nil)                ;do NOT start automatically
;;(setq ac-auto-start 3)                ;automatically start after 3 characters typed

(setq ac-dwim t)                        ;Do what i mean
(setq ac-override-local-map nil)        ;don't override local map
(setq ac-candidate-menu-height 15)
(setq ac-candidate-max 15)

;; Keys to activate and use auto-complete
;;(ac-set-trigger-key "TAB")
(global-set-key "\M-[" 'ac-start)
(define-key ac-complete-mode-map "\M-]" 'ac-stop)

;; The mode that automatically startup.
(setq ac-modes
      '(emacs-lisp-mode lisp-interaction-mode lisp-mode scheme-mode
                        c-mode cc-mode c++-mode java-mode
                        perl-mode cperl-mode python-mode ruby-mode
                        ecmascript-mode javascript-mode php-mode css-mode
                        makefile-mode sh-mode fortran-mode f90-mode ada-mode
                        xml-mode sgml-mode
                        magik-mode))

;; The sources for common all mode.
(custom-set-variables
 '(ac-sources
   '(
     ac-source-imenu
     ac-source-abbrev
     ac-source-words-in-buffer
     ac-source-words-in-same-mode-buffers

     ac-source-magik-classes
     ac-source-magik-methods

     )))



(provide 'auto-complete-init)

