
;;****************** Magik Files/Methods Headings *****************************

(defcustom revision-history-start-tag "---------------- Revision History -----------------"
  "identifier used to mark the start of the revision history of the file."
  :type 'string
  :group 'misc-custom)

(defcustom revision-history-end-tag "-------------- end revision history ---------------"
  "identifier used to mark the end of the revision history of the file."
  :type 'string
  :group 'misc-custom)

(setq file-header-disclaimer (concat "## Project Files\n"))

;; ------------------------------------------------------------------------------
;; Empty *.MAGIK file header
;; ------------------------------------------------------------------------------
(defun insert-programmer-file-header ()
  ""
  (interactive)
  (goto-char (point-min))
  (insert (concat "#% text_encoding = iso8859_1\n"
		  "_package sw\n\n"
		  "##-------------------------------------------------------------------------\n"
		  "##\n"
		  "##     C o m p a n y   N a m e \n"
		  "##\n"
		  "##     Date                 : " (time-stamp-string) "\n"
		  "##     Creator              : " programmer-tag "\n"
		  "##     Project              : Project Name\n"
		  "##\n"
		  "##\n"
          "##     Copyright (C) Company Name , all rights reserved.\n"
		  "##-------------------------------------------------------------------------\n"
		  "## <short description of the class and the interface>\n"
		  "##\n"
		  "##\n"
		  "##-------------------------------------------------------------------------\n\n\n"
		  )
	  )
  )

;; ------------------------------------------------------------------------------
;; Custom Method header
;; ------------------------------------------------------------------------------
(defun method-comment ()
(interactive)
  (let (ret_string)
    (setq ret_string (concat "\t##\n"
			     "\t##\n"
			     "\t##\n"
;                "\t#\n"
;                "\t#"revision-history-start-tag "\n"
;                "\t# (" (time-stamp-string) ") : Created\n"
;                "\t#" revision-history-end-tag "\n"
			     )
	  )
    ret_string
    )
)

;; ------------------------------------------------------------------------------
;; Programmer note tag
;; ------------------------------------------------------------------------------
(defun programmer-note ()
  "a string of date tag and programmer-tag."
  (interactive)
  (concat "# ("
      (time-stamp-string)
      " "
      (if (equal nil programmer-tag)
          (user-login-name)
        programmer-tag)
      ") : "
      )
  )

(defun programmer-modified-note ()
  "a concat string of programmer-note and  'Modified' "
  (interactive)
  (concat (programmer-note)
      "Modified."
      )
  )

(defun insert-change-note ()
  (interactive)
  (if (and cua-mode (eq major-mode 'magik-mode))
      (progn
    (if (not mark-active) (simple-change-note)
      (progn
        (message "CUA MODE ON")
          (cua-cut-region 0)
          (magik-indent-command)
          (insert "# START CHANGE\n")
          (magik-indent-command)
          (insert (concat(programmer-note)"\n\n"))
          (setq mark-active nil)
          (cua-paste 0)
          (insert "\n\n")
          (magik-indent-command)
          (insert "#\n")
          (magik-indent-command)
          (insert "# END CHANGE")
        )
    )
    )
    (simple-change-note)
    )
)

(defun simple-change-note ()
  (setq cur-col (current-column))
  (insert "# START CHANGE\n")
  (indent-to cur-col)
  (insert (concat(programmer-note)"\n"))
  (indent-to cur-col)
  (insert "#\n\n")
  (indent-to cur-col)
  (insert "#\n")
  (indent-to cur-col)
  (insert "# END CHANGE")
)
