
;; ===================================================================
;; Additional Magik Font Faces
;; ===================================================================
;;

(defface magik-font-lock-brackets-face
  '((((type tty) (class color)) (:foreground "red" :height 1.1))
    (((class color) (background light)) (:foreground "Red" :height 1.1))
    (((class color) (background dark)) (:foreground "Red" :height 1.1))
    (t (:bold t)))
  "Font-lock Face to use when displaying Magik code brackets.
Based upon `font-lock-keyword-face'"
  :group 'magik-faces)

(defface magik-font-lock-note-face
  '((((type tty) (class color)) (:background "cyan1" :foreground "navy" :box (:line-width 1 :color "white" :style pressed-button) :weight bold :slant italic))
    (((class color) (background light)) (:background "cyan1" :foreground "navy" :box (:line-width 1 :color "white" :style pressed-button) :weight bold :slant italic))
    (((class color) (background dark)) (:background "cyan1" :foreground "navy" :box (:line-width 1 :color "white" :style pressed-button) :weight bold :slant italic))
    (t (:bold t)))
  "Font-lock Face to use when displaying Magik code 'bright' comments.
Based upon `font-lock-keyword-face'"
  :group 'magik-faces)

(defface magik-font-lock-parameter-face
  '((((type tty) (class color)) (:foreground "deep pink" :weight bold))
    (((class color) (background light)) (:foreground "deep pink" :weight bold))
    (((class color) (background dark)) (:foreground "deep pink" :weight bold))
    (t (:bold t)))
  "Font-lock Face to use when displaying Magik code parameters with 'p_' prefix.
Based upon `font-lock-keyword-face'"
  :group 'magik-faces)

(defface magik-font-lock-local-face
  '((((type tty) (class color)) (:foreground "purple" :weight bold))
    (((class color) (background light)) (:foreground "purple" :weight bold))
    (((class color) (background dark)) (:foreground "purple" :weight bold))
    (t (:bold t)))
  "Font-lock Face to use when displaying Magik code local variables with 'l_' prefix.
Based upon `font-lock-keyword-face'"
  :group 'magik-faces)

(defface magik-font-lock-iterator-face
  '((((type tty) (class color)) (:foreground "IndianRed" :slant italic :weight bold :height 1.1))
    (((class color) (background light)) (:foreground "IndianRed" :slant italic :weight bold :height 1.1))
    (((class color) (background dark)) (:foreground "IndianRed" :slant italic :weight bold :height 1.1))
    (t (:bold t)))
  "Font-lock Face to use when displaying Magik code iterators variable with 'i_' prefix.
Based upon `font-lock-keyword-face'"
  :group 'magik-faces)


(defface magik-font-lock-optional-face
  '((((type tty) (class color)) (:foreground "dark orange" :weight bold))
    (((class color) (background light)) (:foreground "dark orange" :weight bold))
    (((class color) (background dark)) (:foreground "dark orange" :weight bold))
    (t (:bold t)))
  "Font-lock Face to use when displaying Magik code optional parameters with 'o_' prefix.
Based upon `font-lock-keyword-face'"
  :group 'magik-faces)

(defface magik-font-lock-classname-face
  '((((type tty) (class color)) (:foreground "DarkViolet" :weight bold))
    (((class color) (background light)) (:foreground "DarkViolet" :weight bold))
    (((class color) (background dark)) (:foreground "DarkViolet" :weight bold))
    (t (:bold t)))
  "Font-lock Face to use when displaying Magik code class in the method line.
Based upon `font-lock-keyword-face'"
  :group 'magik-faces)

(defface magik-font-lock-methodname-face
  '((((type tty) (class color)) (:foreground "blue" :weight bold))
    (((class color) (background light)) (:foreground "blue" :weight bold))
    (((class color) (background dark)) (:foreground "blue" :weight bold))
    (t (:bold t)))
  "Font-lock Face to use when displaying Magik code method name in the method line.
Based upon `font-lock-keyword-face'"
  :group 'magik-faces)

(defcustom magik-font-lock-methodname-face 'magik-font-lock-methodname-face
  "*Font-lock Face to use when displaying Magik code method name in the method line."
  :group 'magik
  :type 'face)

(defcustom magik-font-lock-classname-face 'magik-font-lock-classname-face
  "*Font-lock Face to use when displaying Magik code class in the method line."
  :group 'magik
  :type 'face)


(defcustom magik-font-lock-brackets-face 'magik-font-lock-brackets-face
  "*Font-lock Face to use when displaying Magik code brackets."
  :group 'magik
  :type 'face)

(defcustom magik-font-lock-note-face 'magik-font-lock-note-face
  "*Font-lock Face to use when displaying Magik code 'bright' comments."
  :group 'magik
  :type 'face)

(defcustom magik-font-lock-parameter-face 'magik-font-lock-parameter-face
  "*Font-lock Face to use when displaying Magik code parameters with 'p_' prefix."
  :group 'magik
  :type 'face)

(defcustom magik-font-lock-optional-face 'magik-font-lock-optional-face
  "*Font-lock Face to use when displaying Magik code optional parameters with 'o_' prefix."
  :group 'magik
  :type 'face)

(defcustom magik-font-lock-iterator-face 'magik-font-lock-iterator-face
  "*Font-lock Face to use when displaying Magik code iterators variable with 'i_' prefix."
  :group 'magik
  :type 'face)

(defcustom magik-font-lock-local-face 'magik-font-lock-local-face
  "*Font-lock Face to use when displaying Magik code local variables with 'l_' prefix."
  :group 'magik
  :type 'face)

(setq magik-font-lock-keywords-4
      (append
       '(
          ("[]{}()\[]" . magik-font-lock-brackets-face)
          ;("#@.*$" 0 magik-font-lock-note-face t)
          ("\\<p_[a-zA-Z0-9_?!]+\\>" 0 magik-font-lock-parameter-face t )
          ("\\<o_[a-zA-Z0-9_?!]+\\>" 0 magik-font-lock-optional-face t)
          ("\\<l_[a-zA-Z0-9_?!]+\\>". magik-font-lock-local-face)
          ("\\<i_[a-zA-Z0-9_?!]+\\>". magik-font-lock-iterator-face)
          ("#@.*$" 0 magik-font-lock-note-face t)
        )
       magik-font-lock-keywords-4
       )
)


;; ===================================================================
;; Additional IMenu customisation
;; ===================================================================
(cond (window-system
       (define-key global-map [C-down-mouse-2] 'imenu)))
(setq
  imenu-sort-function   'imenu--sort-by-name
  imenu-max-items       25)

;**********************************************
;  LIG add menu item to display just methods names ???? not working??
;**********************************************
(setq magik-imenu-expression
      (append '(
         ("*Class.Methods*"
     "^\\s-*\\(_abstract\\(\n\\|\\s-\\)+\\)?\\(_private\\(\n\\|\\s-\\)+\\)?\\(_iter\\(\n\\|\\s-\\)+\\)?_method\\s-+\\(\\sw*\\(\\s$\\S$*\\s$\\sw*\\)?\\.\\sw*\\(\\s$\\S$*\\s$\\sw*\\)?\\)" magik-imenu-method-name 7)
         ("*All Methods* A-Z"
     "^\\(_private +\\|_iter +\\|\\)_method\\s-+\\([-A-Za-z0-9!_+*|:/]+\\)\\.\\([-A-Za-z0-9!_ +*|:/?< (,)]+\\)" 3)
               )
       magik-imenu-expression
       )
)

(defun magik-in-comment-string ()
  "Return non-nil if point is in a Magik comment or string."
   ;(interactive)
  (cond
   ((save-excursion
        (back-to-indentation)
        (looking-at "##?")))       ;in a comment
   ((not (looking-at "[ \t]*$")))  ;in closed string
   ((save-excursion
      (re-search-backward "[#\"]" (point-bol) t)) t) ;in open string
   )
)

(setq magik-work-buffer "**TEMP**.magik")


;**********************************************
;  Customisation for hideshow mode
;**********************************************
; Clearly included here "_" and "end" to spped up the search and
; comparison
(defvar magik-sexp-alist '(("_if" . "_endif")
			   ("_loop" . "_endloop")
			   ("_lock" . "_endlock")
			   ("_block" . "_endblock")
			   ("_catch" . "_endcatch")
			   ("_try" . "_endtry")
			   ("_protect" . "_endprotect")
			   ("_method" . "_endmethod")
			   ("_proc" . "_endproc")
			   ))

(defun magik-forward-sexp (&optional arg)
 "Forward to code block end"
 (save-match-data
 (let ((stackheight 0)
       (regexp ""))
   (setq regexp (concat "\\<\\("
			(mapconcat 'car magik-sexp-alist "\\|") "\\|"
			(mapconcat 'cdr magik-sexp-alist "\\|") "\\)\\>") )

   (re-search-forward regexp nil t arg)
   (setq stackheight 1)
   (while (> stackheight 0)
     (re-search-forward regexp nil t arg)
     (if (or
      (string= "_endif"   (match-string 1))
      (string= "_endloop" (match-string 1))
      (string= "_endprotect" (match-string 1))
      (string= "_endlock" (match-string 1))
      (string= "_endblock" (match-string 1))
      (string= "_endcatch" (match-string 1))
      (string= "_endtry" (match-string 1))
      (string= "_endproc" (match-string 1))
      (string= "_endmethod" (match-string 1))
      )
         (setq stackheight (- stackheight 1))
       (setq stackheight (+ stackheight 1)))))))

(add-to-list 'hs-special-modes-alist
	     `(magik-mode
	       ,(concat "\\(?:\\<\\(" (mapconcat 'car magik-sexp-alist "\\|") "\\)\\>\\)")
	       ,(concat "\\(?:\\<\\(" (mapconcat 'cdr magik-sexp-alist "\\|") "\\)\\>\\)")
	       "##"                     ; comment prefix
             magik-forward-sexp))



;**********************************************
;  LIG attempt to customise the method display in the mode-line
;**********************************************

(defun magik-method-name-set-text-properties (buf method)
  "Return string combining BUF and METHOD suitable for display in mode-line."
  ;;propertize only on Emacs 21 so we use add-text-properties
  (add-text-properties 0 (length buf)
               (list
            'face '(:weight bold)
            'help-echo
            (purecopy "mouse-1: previous buffer, mouse-3: next buffer")
            'local-map mode-line-buffer-identification-keymap)
               buf)
  (add-text-properties 0 (length method)
               (list
            'face '(:inverse-video t)
            'help-echo
            (purecopy "mouse-1: previous buffer, mouse-3: next buffer")
            'local-map mode-line-buffer-identification-keymap)
               method)
  (concat buf "[" method "]"))

;**********************************************
;  LIG customised function to display Magik method name in the mode-line
;**********************************************

(defun which-function ()
  "Return current function name based on point.
Uses `which-func-functions', `imenu--index-alist'
or `add-log-current-defun-function'.
If no function name is found, return nil."
  (let ((name
	 ;; Try the `which-func-functions' functions first.
	 (run-hook-with-args-until-success 'which-func-functions)))
    ;; Borrowed from magik.el - works better with magik code
    (when (and (null name)
	       (eq major-mode 'magik-mode))
      (let ((this-syntax-table (copy-syntax-table magik-mode-syntax-table))
	    (buf (format "%-12s " (buffer-name)))
	    magik-name
	    pt end)
	(condition-case err
	    (save-excursion
	      (setq magik-name "" )
	      (save-match-data
		(modify-syntax-entry ?_ "w" this-syntax-table)
		(set-syntax-table this-syntax-table)
		(cond ((save-excursion
			 ;;method creation methods, currently ignores pragma
			 (setq pt (point))
			 (and (search-forward ")" nil t)
			      (search-backward "(" nil t)
			      (progn (beginning-of-line) t)
			      (<= (point) pt)
			      (looking-at "^\\s-*\\sw+\.def\\(ine_\\(slot_access\\|shared_constant\\|shared_variable\\|property\\)\\|_property\\)([ \t\n]*:\\s-*\\(\\sw*\\(\\s$\\S$*\\s$\\sw*\\)?\\)")))
		       (setq magik-name (match-string-no-properties 3)))
		      ((save-excursion
			 ;;arrays
			 (beginning-of-line)
			 (setq pt (point))
			 (and (forward-endmethod t) (setq end (point))
			      (backward-method t)
			      (<= (point) pt)
			      (re-search-forward "^\\s-*_method\\s-+\\(\\sw*\\(\\s$\\S$*\\s$\\sw*\\)?\\)\\s-*?\\[" end t)))
		       (setq magik-name (car (magik-imenu-method-name 1))))
		      ((save-excursion
			 ;;normal methods
			 (beginning-of-line)
			 (setq pt (point))
			 (and (forward-endmethod t)
			      (backward-method t)
			      (<= (point) pt)
			      (re-search-forward "^.*\\b_method\\s-+\\sw*\\(\\s$\\S$*\\s$\\sw*\\)?\\.\\(\\sw*\\(\\s$\\S$*\\s$\\sw*\\)?\\)\\(\\s-*\\^?<<\\)?" nil t)))
		       (setq magik-name (car (magik-imenu-method-name 2))))
		      (t nil)))
	      (setq name magik-name))
	  (error (setq name "") ))
	(set-syntax-table magik-mode-syntax-table)
	name) ;let
      );when

    ;; If Imenu is loaded, try to make an index alist with it.
    (when (and (null name)
	       (boundp 'imenu--index-alist) (null imenu--index-alist)
	       (null which-function-imenu-failed))
      (imenu--make-index-alist t)
      (unless imenu--index-alist
	(make-local-variable 'which-function-imenu-failed)
	(setq which-function-imenu-failed t)))
    ;; If we have an index alist, use it.
    (when (and (null name)
	       (boundp 'imenu--index-alist) imenu--index-alist)
      (let ((alist imenu--index-alist)
            (minoffset (point-max))
            offset pair mark imstack namestack)
        ;; Elements of alist are either ("name" . marker), or
        ;; ("submenu" ("name" . marker) ... ). The list can be
        ;; arbitrarily nested.
        (while (or alist imstack)
          (if alist
              (progn
                (setq pair (car-safe alist)
                      alist (cdr-safe alist))

                (cond ((atom pair))     ; skip anything not a cons

                      ((imenu--subalist-p pair)
                       (setq imstack   (cons alist imstack)
                             namestack (cons (car pair) namestack)
                             alist     (cdr pair)))

                      ((number-or-marker-p (setq mark (cdr pair)))
                       (if (>= (setq offset (- (point) mark)) 0)
                           (if (< offset minoffset) ; find the closest item
                               (setq minoffset offset
                                     name (funcall
                                           which-func-imenu-joiner-function
					   (reverse (cons (car pair)
							  namestack)))))))))
            (setq alist     (car imstack)
                  namestack (cdr namestack)
                  imstack   (cdr imstack))))))

    ;; Try using add-log support.
    (when (and (null name) (boundp 'add-log-current-defun-function)
	       add-log-current-defun-function)
      (setq name (funcall add-log-current-defun-function)))
    ;; Filter the name if requested.
    (when name
      (if which-func-cleanup-function
	  (funcall which-func-cleanup-function name)
	name))))


;**********************************************
;  LIG redefine method electric templates to
;  include custom method header/comment
;**********************************************

(setq magik-electric-templates
  (append
   '(("iter" e 1 (prev_pragma "_pragma(classify_level=, topic={}, usage={})")
      ("_iter _method " prev_class_name) method-header - "_endmethod" dollar)
     ("private" e 1 (prev_pragma "_pragma(classify_level=restricted, topic={}, usage={})")
      ("_private _method " prev_class_name) method-header - "_endmethod" dollar)
     ("abstract" e 1 (prev_pragma "_pragma(classify_level=, topic={}, usage={})")
      ("_abstract _method " prev_class_name) method-header - "_endmethod" dollar)
     ("method" e 1 (prev_pragma "_pragma(classify_level=, topic={}, usage={})")
      ("_method " prev_class_name) method-header - "_endmethod" dollar)
     ("pragma" 17 0 (prev_pragma "_pragma(classify_level=, topic={}, usage={})"))
     ("def_slotted_exemplar" e 2 (prev_pragma "_pragma(classify_level=, topic={}, usage={})")
      ("def_slotted_exemplar(" filename_as_symbol ",\n\t## \n\t## \n\t## \n\t{\n\t},\n\t{})\n" dollar))

     ("if" e 0 "_if " "_then" - "_endif")
     ("over" e 0 "_over " "_loop" - "_endloop")
     ("catch" e 1 "_catch" - "_endcatch")
     ("block" e 1 "_block" - "_endblock")
     ("protect" e 1 "_protect" - "_protection" - "_endprotect")
     ("lock" e 0 "_lock " - "_endlock")
     ("try" e 1 "_try" - "_when" - "_endtry")
     ("proc" e 0 "_proc " - "_endproc")
     ("loop" e 1 "_loop" - "_endloop")
     ("for" 2 0 "_for  _over " "_loop" - "_endloop"))
   magik-electric-templates-methods))


;**********************************************
;  LIG modify this function to use the
;  custom method header/comment
;**********************************************

(defun electric-insert-template-line (name line col)
  "Interpret one line of the electric template."
  (if (and (listp line)
	   (not (eq (car line) 'prev_pragma)))
      ;;RECURSIVE
      (dolist (x line)
        (electric-insert-template-line name x col))
    (run-hook-with-args 'electric-insert-template-line-pre-hook name line col)
    (cond
     ((and (listp line)
	   (eq (car line) 'prev_pragma))
      (if (save-excursion
	    (re-search-backward "^_pragma([^)]*)" nil t))
	  (let ((str (match-string 0))
		(pt (point)))
	    (insert str)
	    (save-excursion
	      (and (string-match "classify_level=deprecated" str) ;Was it deprecated?
		   (goto-char pt)                                 ;place point ready to insert deprecated template
		   (pragma-insert-magik-deprecated-template)      ;because this fn assumes that it is on the pragma line
		   )))
	(insert (cadr line))))
      ((eq line '-)
       (magik-indent-command))
      ;;----------LIG MOD -------------------------
      ((eq line 'method-header)
       (insert-method-comment))
      ;;---------- END LIG MOD -------------------------
      ((eq line 'dollar)
       (delete-region (point-bol) (point))
       (insert "$\n"))
      ((eq line 'prev_class_name)
       (let (class)
	 (save-excursion
	   (cond ((re-search-backward "_method[ \t]+\\(\\(\\sw\\|_\\)+\\)\\." nil t)
		  (setq class (match-string 1)))
		 ((re-search-backward "def_slotted_exemplar\\s-*(\\(\\s-\\|\n\\)*:\\(\\(\\sw\\|_\\)+\\)" nil t)
		  (setq class (match-string 2)))
		 (t nil)))
	 (if class (insert class "."))))
      ((eq line 'filename_as_symbol)
       (let ((name (buffer-name)))
	 (if (string-match "\\.magik$" name)
	     (setq name (substring name 0 (- (length name) 6))))
	 (insert ":" name)))
      ((eq (string-to-char line) ?\t)
       (indent-to (+ col magik-indent-level))
       (insert (substring line 1)))
      (t
       (indent-to col)
       (insert line)))
    (run-hook-with-args 'electric-insert-template-line-post-hook name line col)))


;**********************************************
;; LIG - modified to switch to the buffer,
;; where the region was copied and
;; go to the end of this buffer
;**********************************************

(defun magik-copy-region-to-buffer (start end &optional buffer)
  "Copy region to BUFFER.
 If BUFFER is nil, use buffer name stored in variable `magik-work-buffer'
otherwise prompt user."
  (interactive "r")
  (setq buffer (or buffer magik-work-buffer (read-buffer "Buffer: ")))

  (let ((code (buffer-substring start end)))
    (set-buffer (get-buffer-create buffer))
    (goto-char (point-max))
    (or (looking-at "^") (insert "\n"))
    (insert code "\n")
    (set-buffer-modified-p nil)
    (magik-mode))
  ;;----------LIG MOD -------------------------
  ;(display-buffer buffer)
  (switch-to-buffer-other-window buffer)
  (end-of-buffer)
  ;;----------LIG MOD -------------------------
)

(defun lig_magik-trace-curr-statement ()
  "Add a trace statement for the current statement."
  (interactive "*")
  (back-to-indentation)
  (let
      ((col (current-column))
       (str (gsub (buffer-substring-no-properties
		   (point) (point-eol)) "\"" "\" + %\" + \"")))
    (end-of-line)
    (insert "\nwrite(\""
            ;; (make-string col ? ) ;;;; withdrawn.
            "+++ "
            str
            " +++\")")))

(provide 'custom-magik)

;; EOF
