;;;nxml-mode requires Emacs 21 and above. 
(require 'cl)

(if (or xemacs-p (< emacs-major-version 21))
    nil ;;NXML code will not load into Emacs versions less than 21.

  ;;Configure our defaults...
  (defvar nxml-child-indent 4)
  (defvar nxml-attribute-indent 4)
  (defvar nxml-slash-auto-complete-flag 1)
  
  (let ((nxml     "\\.\\(xml\\|xsl\\|rng\\|xhtm?l?\\|html?\\)\\'")
	(rnc      "\\.rnc\\'")
	(default-directory (directory-file-name (file-name-directory load-file-name))))
    (or (assoc nxml auto-mode-alist)
	(push (cons nxml 'nxml-mode) auto-mode-alist))
    (or (assoc rnc  auto-mode-alist)
	(push (cons rnc  'rnc-mode) auto-mode-alist)))

  (require 'rnc-mode)
  ;;Load the package to set up autoloads for nXML etc
  ;;This code automatically updates load-path too.
  (load "nxml-mode/rng-auto"))

(provide 'sw-nxml)
